using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;

namespace JNBTest
{
	public delegate void clickDelegate(String str);

	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class JNBControl : System.Windows.Forms.UserControl
	{
		public System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private IntPtr pParent;
		private System.Windows.Forms.Label label1;
		private clickDelegate cd = null;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		//public delegate void HelloClicked();
		
		public JNBControl()
		{
			this.pParent = IntPtr.Zero;
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		public JNBControl(IntPtr Parent)
		{
			this.pParent = Parent;
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}
		
		/// <summary>
		/// Get the <see cref="System.Windows.Forms.CreateParams"/>
		/// used to create the control.  This override creates the
		/// control under the given parent.  We also add a border
		/// to make the embedded control easier to identify.
		/// </summary>
		/// 
		const int WS_BORDER=0x00800000;
		const int WS_EX_STATICEDGE=0x00020000;
		protected override CreateParams CreateParams
		{
			get
			{
				CreateParams cp = base.CreateParams;
				if (this.pParent != IntPtr.Zero)
					cp.Parent = this.pParent;
				cp.Style |= WS_BORDER;
				//cp.ExStyle |= WS_EX_STATICEDGE;
				return cp;
			}
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 58);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(120, 22);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(152, 56);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(56, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Send";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 7.8F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(176, 32);
			this.label1.TabIndex = 2;
			this.label1.Text = ".NET UserControl";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// JNBControl
			// 
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.textBox1);
			this.Name = "JNBControl";
			this.Size = new System.Drawing.Size(224, 104);
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			if (this.textBox1.Text.Length == 0) 
			{
				MessageBox.Show("Please enter your name.", "Error",
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				textBox1.Focus();
			}

			else 
			{
				if (this.cd != null)
					cd(this.textBox1.Text);	// call the callback
//				MessageBox.Show(
//					String.Format("Hello, {0}!", this.textBox1.Text),
//					"Hello", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}

		public void registerClickDelegate(clickDelegate cd)
		{
			this.cd = cd;
		}
	}

}
