package javaTest;

import com.jnbridge.jnbcore.*;
import com.jnbridge.jnbtools.*;

import JNBTest.*;
import java.awt.*;
import java.awt.event.*;
import com.jnbridge.embedding.DotNetControl;
import System.IntPtr;

public class MainClass {
	
	static TextField echo;
	
	public static class ClickEventHandler implements clickDelegate
	{
		public void Invoke(String message)
		{
			echo.setText(message);
		}
	}

	public static void main(String[] args) {
		// configure JNBridgePro
		DotNetSide.init(args[0]);
		
		Frame f = new Frame();
		f.setLayout(new GridBagLayout());
		f.setTitle("Test - Embedded .NET Control");
		f.setBackground(Color.LIGHT_GRAY);
		f.setSize(385, 200);

		Font font = new Font("Sans Serif", Font.BOLD, 14);

		Label lLeft = new Label(".NET UserControl");
		lLeft.setFont(font);

		GridBagConstraints lLeftConstraints = new GridBagConstraints();
		lLeftConstraints.gridx = 0;
		lLeftConstraints.gridy = 0;
		lLeftConstraints.gridwidth = 1;
		lLeftConstraints.gridheight = 1;
		lLeftConstraints.fill = GridBagConstraints.HORIZONTAL;
		lLeftConstraints.anchor = GridBagConstraints.NORTHWEST;
		lLeftConstraints.insets = new Insets(3, 3, 1, 5);
		f.add(lLeft, lLeftConstraints);

		echo = new TextField("", 15);

		GridBagConstraints dncConstraints = new GridBagConstraints();
		dncConstraints.gridx = 0;
		dncConstraints.gridy = 1;
		dncConstraints.gridwidth = 1;
		dncConstraints.gridheight = 1;
		dncConstraints.fill = GridBagConstraints.NONE;
		dncConstraints.anchor = GridBagConstraints.NORTHWEST;
		dncConstraints.insets = new Insets(0, 3, 3, 5);

		//
		// this is the part where we create and embed the .NET control
		//
		
		// create the .NET control
		JNBControl c = new JNBControl();
		// register any callbacks
		c.registerClickDelegate(new ClickEventHandler());
		// wrap it so it can be embedded
		DotNetControl dnc = new DotNetControl(c);
		// size it
		dnc.setSize(224, 104);
		// embed it
		f.add(dnc, dncConstraints);

		Label lRight = new Label("From .NET");
		lRight.setFont(font);

		GridBagConstraints lRightConstraints = new GridBagConstraints();
		lRightConstraints.gridx = 1;
		lRightConstraints.gridy = 0;
		lRightConstraints.gridwidth = 1;
		lRightConstraints.gridheight = 1;
		lRightConstraints.fill = GridBagConstraints.HORIZONTAL;
		lRightConstraints.anchor = GridBagConstraints.NORTHWEST;
		lRightConstraints.insets = new Insets(3, 5, 1, 3);
		f.add(lRight, lRightConstraints);

		GridBagConstraints echoConstraints = new GridBagConstraints();
		echoConstraints.gridx = 1;
		echoConstraints.gridy = 1;
		echoConstraints.gridwidth = 1;
		echoConstraints.gridheight = 1;
		echoConstraints.fill = GridBagConstraints.HORIZONTAL;
		echoConstraints.anchor = GridBagConstraints.NORTHWEST;
		echoConstraints.insets = new Insets(0, 5, 3, 3);
		f.add(echo, echoConstraints);

		f.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				Window w = evt.getWindow();
				w.setVisible(false);
				w.dispose();
			}
		});

		f.setVisible(true);
	}
}
